#ifndef DIVREM_HH
#define DIVREM_HH
#include "exceptions.hh"
#include <gmpxx.h>

// In every case, the remainder is returned with the sign the divisor
// has and the quotient is rounded toward negative infinity.

namespace Interval {
    template<class P, class Q> struct Quotrem;
    Quotrem<long, long>
      divrem(long, long);
    Quotrem<mpz_class, long>
      divrem(const mpz_class &, long);
    Quotrem<mpz_class, mpz_class>
      divrem(const mpz_class &, const mpz_class &);
}

template<class P, class Q> struct Interval::Quotrem {
    P quot;
    Q rem;
};

#endif

