#include "gcd.hh"
#include <cstdlib>
#include <utility>

long Interval::gcd(long p, long q)
{
    if (!q) throw Division_by_zero {};
    const bool was_q_negative {q < 0};
    p = std::labs(p), q = std::labs(q);
    if (p < q) std::swap(p, q);
    while(q) {
        p %= q;
        std::swap(p, q);
    }
    return was_q_negative ? -p : p;
}

long Interval::reduce(long *const pp, long *const qq)
{
    long gcd1 {gcd(*pp, *qq)};
    *pp /= gcd1, *qq /= gcd1;
    return gcd1;
}

