#ifndef RETRIAL_HH
#define RETRIAL_HH

#include "exceptions.hh"
#include "lohi.hh"
#include <gmpxx.h>

namespace Interval {
    template<class... Args>
    inline Lohi retry
    (Lohi (&)(mp_bitcnt_t, Args...), mp_bitcnt_t *ptr_precision, Args... args);
}

template<class... Args>
Interval::Lohi Interval::retry(
    Lohi (&f)(mp_bitcnt_t, Args...),
    mp_bitcnt_t *const ptr_precision, Args... args
)
{
    try { return f(*ptr_precision, args...); }
    catch (const Domain_straddle) {
        ++*ptr_precision;
        return retry(f, ptr_precision, args...);
    }
    throw Impossibility {};
    return Lohi {};
}

#endif

